from UI.CustomWidgets import *


class Widget():
    def setupUI(self):
        lytMain = QVBoxLayout()
        lytMain.addLayout(QHBoxSqueezed(self.createGroupAxisState()))
        lytMain.addLayout(QHBoxSqueezed(self.createGroupParallePortState()))
        lytMain.addLayout(QHBoxSqueezed(self.createGroupSerialCommand()))
        lytMain.addStretch()
        self.setLayout(lytMain)

    def createGroupSerialCommand(self):
        self.txtCommand = QLineEdit()
        self.lblAnswer = QLabelSunken()
        self.btnSendSerialCommand = QPushButton()

        lytSerialCommand = QGridLayout()
        lytSerialCommand.addWidget(QLabel('#'), 1, 1)
        lytSerialCommand.addWidget(self.txtCommand, 1, 2)
        lytSerialCommand.addWidget(QLabel('\\r'), 1, 3)
        lytSerialCommand.addWidget(self.btnSendSerialCommand, 1, 4)
        lytSerialCommand.addWidget(self.lblAnswer, 2, 1, 1, 4)

        self.grpSerialCommand = QGroupBox()
        self.grpSerialCommand.setLayout(lytSerialCommand)
        return self.grpSerialCommand

    def createGroupParallePortState(self):
        self.lblPinText = QLabel()
        self.lblStateText = QLabel()
        self.chkParallelPortPin1 = QCheckBox()
        self.chkParallelPortPin2 = QCheckBox()
        self.chkParallelPortPin3 = QCheckBox()
        self.chkParallelPortPin4 = QCheckBox()
        self.chkParallelPortPin5 = QCheckBox()
        self.chkParallelPortPin6 = QCheckBox()
        self.chkParallelPortPin7 = QCheckBox()
        self.chkParallelPortPin8 = QCheckBox()
        self.chkParallelPortPin9 = QCheckBox()
        self.chkParallelPortPin10 = QCheckBoxDisabled()
        self.chkParallelPortPin11 = QCheckBoxDisabled()
        self.chkParallelPortPin12 = QCheckBoxDisabled()
        self.chkParallelPortPin13 = QCheckBoxDisabled()
        self.chkParallelPortPin14 = QCheckBox()
        self.chkParallelPortPin15 = QCheckBoxDisabled()
        self.chkParallelPortPin16 = QCheckBox()
        self.chkParallelPortPin17 = QCheckBox()

        lytParallelPort = QGridLayout()
        lytParallelPort.addWidget(self.lblPinText, 1, 0)
        lytParallelPort.addWidget(QLabel('<b>I/O</b>'), 2, 0)
        lytParallelPort.addWidget(self.lblStateText, 3, 0)
        lytParallelPort.addWidget(QLabel('O'), 2, 1, Qt.AlignCenter)
        for pin in range(1,18):
            lytParallelPort.addWidget(QLabel(str(pin)), 1, pin, Qt.AlignCenter)
        for pin in range(2, 10):
            lytParallelPort.addWidget(QLabel('I/O'), 2, pin, Qt.AlignCenter)
        lytParallelPort.addWidget(QLabel('O'), 2, 14, Qt.AlignCenter)
        lytParallelPort.addWidget(QLabel('O'), 2, 16, Qt.AlignCenter)
        lytParallelPort.addWidget(QLabel('O'), 2, 17, Qt.AlignCenter)
        for pin in range(10, 14):
            lytParallelPort.addWidget(QLabel('I'), 2, pin, Qt.AlignCenter)
        lytParallelPort.addWidget(QLabel('I'), 2, 15, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin1, 3, 1, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin2, 3, 2, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin3, 3, 3, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin4, 3, 4, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin5, 3, 5, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin6, 3, 6, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin7, 3, 7, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin8, 3, 8, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin9, 3, 9, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin10, 3, 10, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin11, 3, 11, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin12, 3, 12, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin13, 3, 13, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin14, 3, 14, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin15, 3, 15, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin16, 3, 16, Qt.AlignCenter)
        lytParallelPort.addWidget(self.chkParallelPortPin17, 3, 17, Qt.AlignCenter)

        self.grpParallelPort = QGroupBox()
        self.grpParallelPort.setLayout(lytParallelPort)
        return self.grpParallelPort

    def createGroupAxisState(self):
        self.lblAxisXText = QLabel()
        self.lblAxisCText = QLabel()
        self.lblAxisZText = QLabel()

        self.lblByteText = QLabel()
        self.lblPositionErrorText = QLabel()
        self.lblHomeText = QLabel()
        self.lblReadyText = QLabel()
        self.lblReferencedText = QLabel()
        self.lblErrorPositionText = QLabel()
        self.lblErrorCodeText = QLabel()
        self.lblVersionText = QLabel()

        self.lblStatusByteX = QLabelAlignedRight()
        self.lblStatusByteC = QLabelAlignedRight()
        self.lblStatusByteZ = QLabelAlignedRight()
        self.chkPositionErrorX = QCheckBoxDisabled()
        self.chkPositionErrorC = QCheckBoxDisabled()
        self.chkPositionErrorZ = QCheckBoxDisabled()
        self.chkHomeX = QCheckBoxDisabled()
        self.chkHomeC = QCheckBoxDisabled()
        self.chkHomeZ = QCheckBoxDisabled()
        self.chkReadyX = QCheckBoxDisabled()
        self.chkReadyC = QCheckBoxDisabled()
        self.chkReadyZ = QCheckBoxDisabled()
        self.chkIsReferencedX = QCheckBoxDisabled()
        self.chkIsReferencedC = QCheckBoxDisabled()
        self.chkIsReferencedZ = QCheckBoxDisabled()
        self.lblErrorPosX = QLabelAlignedRight()
        self.lblErrorPosC = QLabelAlignedRight()
        self.lblErrorPosZ = QLabelAlignedRight()
        self.lblErrorX = QLabelAlignedRight()
        self.lblErrorC = QLabelAlignedRight()
        self.lblErrorZ = QLabelAlignedRight()
        self.lblVersionX = QLabelSunken()
        self.lblVersionC = QLabelSunken()
        self.lblVersionZ = QLabelSunken()

        lytAxisState = QGridLayout()
        lytAxisState.addWidget(self.lblAxisXText, 1, 0)
        lytAxisState.addWidget(self.lblAxisCText, 2, 0)
        lytAxisState.addWidget(self.lblAxisZText, 3, 0)
        lytAxisState.addWidget(self.lblByteText, 0, 1)
        lytAxisState.addWidget(self.lblPositionErrorText, 0, 2)
        lytAxisState.addWidget(self.lblHomeText, 0, 3)
        lytAxisState.addWidget(self.lblReadyText, 0, 4)
        lytAxisState.addWidget(self.lblReferencedText, 0, 5)
        lytAxisState.addWidget(self.lblErrorPositionText, 0, 6)
        lytAxisState.addWidget(self.lblErrorCodeText, 0, 7)
        lytAxisState.addWidget(self.lblVersionText, 0, 8)
        lytAxisState.addWidget(self.lblStatusByteX, 1, 1)
        lytAxisState.addWidget(self.lblStatusByteC, 2, 1)
        lytAxisState.addWidget(self.lblStatusByteZ, 3, 1)
        lytAxisState.addWidget(self.chkPositionErrorX, 1, 2, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkPositionErrorC, 2, 2, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkPositionErrorZ, 3, 2, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkHomeX, 1, 3, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkHomeC, 2, 3, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkHomeZ, 3, 3, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkReadyX, 1, 4, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkReadyC, 2, 4, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkReadyZ, 3, 4, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkIsReferencedX, 1, 5, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkIsReferencedC, 2, 5, Qt.AlignCenter)
        lytAxisState.addWidget(self.chkIsReferencedZ, 3, 5, Qt.AlignCenter)
        lytAxisState.addWidget(self.lblErrorPosX, 1, 6)
        lytAxisState.addWidget(self.lblErrorPosC, 2, 6)
        lytAxisState.addWidget(self.lblErrorPosZ, 3, 6)
        lytAxisState.addWidget(self.lblErrorX, 1, 7)
        lytAxisState.addWidget(self.lblErrorC, 2, 7)
        lytAxisState.addWidget(self.lblErrorZ, 3, 7)
        lytAxisState.addWidget(self.lblVersionX, 1, 8)
        lytAxisState.addWidget(self.lblVersionC, 2, 8)
        lytAxisState.addWidget(self.lblVersionZ, 3, 8)

        self.grpAxisState = QGroupBox()
        self.grpAxisState.setLayout(lytAxisState)
        return self.grpAxisState
